# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl OO-Attributes.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More tests => 3;
BEGIN { use_ok('OO::Attributes') };

#########################

# Insert your test code below, the Test::More module is use()ed here so read
# its man page ( perldoc Test::More ) for help writing this test script.

package Parent;
use OO::Attributes sub {
  my $self = shift;
  my $name = shift;
  # we have an ordinary hashref for the object
  return \$self->{"_$name"};
}, [qw(city name)];

package Child;
use base "Parent";
use OO::Attributes sub {
  my $self = shift;
  my $name = shift;
  # object is arrayref, and the attributes are stored in element 0
  return \$self->[0]->{"_$name"};
};

package main;
my $parent = {};
bless($parent, "Parent");
$parent->name("parent");
my $child  = [];
bless ($child, "Child");
$child->name("child");
ok($parent->{_name} eq "parent");
ok($child->[0]->{_name} eq "child");

